=== debian/changelog ===
portsentry (1.2-16) unstable; urgency=medium

  * Debian team upload.
  * Move aliased files from / to /usr (DEP17). (Closes: #1085161)

 -- Michael Biebl <biebl@debian.org>  Tue, 15 Oct 2024 18:19:00 +0200

portsentry (1.2-15) unstable; urgency=medium

  * Team upload by debian/ team
    Closes: #1081771

  [ Jelmer Vernooĳ ]
  * Migrate repository from alioth to salsa.

  [ Andreas Tille ]
  * debian/README.source: Replace redundant hint to quilt by hint how
    to possibly get latest commits from Github as new upstream source
  * debian/watch: Add comment to fetch latest upstream commit
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Rules-Requires-Root: binary-targets
  * Trim trailing whitespace.
  * Create automatically portsentry.history
    Closes: #1010718
  * d/rules: drop useless boilerplate comment
  * d/rules: short dh
  * d/rules: Enable hardening options

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #894974)
    + Let dh_auto_build pass cross tools to make.
    + Defer all stripping to dh_strip.

  [ Paulo Henrique de Lima Santana ]
  * Updated d/po/pt_BR.po (Closes: #1028013)

  [ наб ]
  * d/rules: no need for `pwd` or `dh_listpackages`
  * d/post{inst,rm}: stop supporting upgrades from 1.0-2 (unneeded since woody)
  * Add systemd service (Closes: #1039322)
    + the sysvinit unit starts 0/1/2 programs ad lib
    + this is unrepresentable in systemd
    + instead, mask it, ship template, and enable the appropriate
      portsentry@tcp.service and portsentry@udp.service
  * Make portsentry-build-ignore-file idempotent
  * debian/{po/{de,fr,nb}.po,portsentry.conf.5}: lintian national-encoding
  * d/prerm: lintian command-with-path-in-maintainer-script
  * d/control: lintian skip-systemd-native-flag-missing-pre-depends
  * d/NEWS: mention the new systemd setup

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 04 Oct 2024 01:05:13 +0200

portsentry (1.2-14) unstable; urgency=medium

  * debian/control:
    - Bump standards version to 3.9.2.
    - Update debhelper compatibility to 9
  * debian/patch:
    + Add debian/patches/01_dpkg-buildflags.diff to complete hardening
      options. Thanks to Guillaume Delacour <gui@iroqwa.org>
      (Closes: #763158)
  * debian/copyright:
    - Fix DEP-5 compatibility issues
    - Update copyright years
  * debian/portsentry.init.d:
    - Add source /lib/lsb/init-functions
    - Set Required-Start dependency to $syslog

 -- Dario Minnucci <midget@debian.org>  Wed, 29 Oct 2014 12:34:30 +0100

portsentry (1.2-13) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * debian/control:
    - Bump standards version to 3.9.2.
    - Remove references to quilt.
    - Update debhelper compatibility to 8.
    - Added Vcs-Git and Vcs-Browser fields.
  * debian/rules:
    - Remove references to quilt.
    - Added missing recommended targets (build-arch and build-indep)
  * debian/portsentry.docs:
    - Install upstream's changelog just once.
  * debian/copyright: Updated to be DEP-5 compatible.
  * debian/po:
    - Added Danish translation. Thanks to Joe Dalton. (Closes: #653746)

 -- Dario Minnucci <midget@debian.org>  Sat, 14 Jan 2012 15:28:20 +0100

portsentry (1.2-12) unstable; urgency=low

  * Adopting portsentry
  * Acknowledge NMU, thanks to Petter Reinholdtsen. (Closes: #547058)
  * debian/control:
    - Maintainers address updated
    - Added quilt to Build-Depends
    - Bump standard version to 3.8.3: Added debian/README.source
    - Adding 'Homepage:' field
    - Adding ${misc:Depends} to fix lintian W: debhelper-but-no-misc-depends
  * debian/watch: Added.
  * Move files and dirs outside upstream sources (into ./debian directory):
    - [DIR]  scripts
    - [FILE] portsentry.conf.Debian
    - [FILE] portsentry.ignore.static
  * Some files were renamed under debian directory:
    - debian/dirs   -->  debian/portsentry.dirs
    - debian/docs   -->  debian/portsentry.docs
    - debian/init.d -->  debian/portsentry.init.d
  * debian/rules: Added quilt support
  * debian/patches: Added patches to revert changes made on upstream files
    - 00_fix_Makefile.patch
    - 00_fix_portsentry_config.h.patch
    - 00_fix_portsentry.c.patch
    - 00_fix_README.install.patch


 -- Dario Minnucci <midget@debian.org>  Fri, 22 Jan 2010 12:32:46 +0100

portsentry (1.2-11.3) unstable; urgency=low

  * Non-maintainer upload to fix release goal.
  * Fix incorrect provides in init.d script (Closes: #542600).
  * Make init.d script depend on $all to start last in the boot sequence
    (Closes: #539257).
  * Fix typo in portsentry(8) manual page (Closes: #431304).
  * Remove redundant code from postinst.  The same code is inserted
    by dh_installinit.
  * Make sure errors are not ignored in prerm.
  * Move to debhelper versjon 7.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Sep 2009 00:13:57 +0200

portsentry (1.2-11.2) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Add LSB headers to init script. Closes: #462220
  * Debconf translations:
    - Vietnamese. Closes: #426849
    - Romanian. Closes: #411385
    - Norwegian Bokmål. Closes: #414463
    - Dutch. Closes: #419404
    - Finnish. Closes: #448189
    - Italian. Closes: #422006
  * [Lintian] Add a copyright mention in debian/copyright
  * [Lintian] Do not ignore errors from "make distclean" in
    debian/rules

 -- Christian Perrier <bubulle@debian.org>  Wed, 20 Feb 2008 20:02:49 +0100

portsentry (1.2-11.1) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Debconf translations:

