=== debian/control ===
Source: portsentry
Maintainer: Dario Minnucci <midget@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/portsentry
Vcs-Git: https://salsa.debian.org/debian/portsentry.git
Homepage: http://sentrytools.sourceforge.net/
Rules-Requires-Root: binary-targets

Package: portsentry
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         net-tools,
         procps,
         libfile-temp-perl,
         debconf | debconf-2.0
Recommends: tcpd
Suggests: logcheck
Description: Portscan detection daemon
 PortSentry has the ability to detect portscans(including stealth scans) on
 the network interfaces of your machine. Upon alarm it can block the
 attacker via hosts.deny, dropped route or firewall rule. It is part of the
 Abacus program suite.
 .
 Note: If you  have no idea what a port/stealth scan is, It's recommended to
 have a look at http://sf.net/projects/sentrytools/ before installing this
 package. Otherwise you might easily block hosts you'd better not (e.g. your
 NFS-server, name-server, etc.).
