=== debian/watch ===
version=4
http://sf.net/sentrytools/portsentry-(.+)\.tar\.gz

# See README.source about fetching latest commits
#opts="mode=git,pretty=1.2+git%cd.%h" \
#    https://github.com/Perdjesk/portsentry.git HEAD
