=== debian/changelog ===
portsentry (2.0.5-2) unstable; urgency=medium

  * Updated German translations, fixing bug (Closes: #1116975)

 -- Marcus Hufvudsson <mh@protohuf.com>  Fri, 03 Oct 2025 03:13:26 +0000

portsentry (2.0.5-1) unstable; urgency=medium

  [ Marcus Hufvudsson ]
  * Update to latest upstream version
  * Fixed lintian warning maintainer-script-lacks-debhelper-token
  * Revert old conf template for now
  * Remove obsolete message and change file encoding for swedish translation
    to UTF8
  * Fixed malformed-title-in-templates
  * Ran debconf-updatepo after fixing template message

  [ Andreas Tille ]
  * d/watch: Fix download name of new upstream source

 -- Marcus Hufvudsson <mh@protohuf.com>  Sun, 14 Sep 2025 16:55:25 +0200
