=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/portsentry/portsentry/tags .*/v?(\d.*)@ARCHIVE_EXT@
