=== debian/changelog ===
portsentry (2.0.6-1) unstable; urgency=medium

  * Updated Dutch translations (Closes: #1118208)
  * Updated Portuguese translations (Closes: #1119829)
  * Updated to new upstream version, 2.0.6
  * As of Portsentry 2.0 the default config won't cause bug #795186 to happen.
    (Closes: #795186)

 -- Marcus Hufvudsson <mh@protohuf.com>  Sun, 02 Nov 2025 12:14:07 +0000
