=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Marcus Hufvudsson <mh@protohuf.com>
 Section: net
 Priority: optional
-Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev
+Build-Depends: debhelper-compat (= 13), cmake, libpcap-dev, pkgconf, systemd-dev
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/portsentry
 Vcs-Git: https://salsa.debian.org/debian/portsentry.git
